"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InjectRepository = exports.ENTITY_MODEL_KEY = exports.BaseTable = void 0;
const core_1 = require("@midwayjs/core");
const sequelize_typescript_1 = require("sequelize-typescript");
function BaseTable(arg) {
    if (typeof arg === 'function') {
        (0, core_1.saveModule)('sequelize:core', arg);
        annotate(arg);
    }
    else {
        const options = Object.assign({}, arg);
        return target => {
            (0, core_1.saveModule)('sequelize:core', target);
            annotate(target, options);
        };
    }
}
exports.BaseTable = BaseTable;
function annotate(target, options = {}) {
    (0, sequelize_typescript_1.setModelName)(target.prototype, options.modelName || target.name);
    (0, sequelize_typescript_1.addOptions)(target.prototype, options);
}
exports.ENTITY_MODEL_KEY = 'sequelize:entity_model_key';
function InjectRepository(modelKey, connectionName) {
    return (0, core_1.createCustomPropertyDecorator)(exports.ENTITY_MODEL_KEY, {
        modelKey,
        connectionName,
    });
}
exports.InjectRepository = InjectRepository;
//# sourceMappingURL=decorator.js.map